# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################

#import datetime
from osv import fields,osv
import pooler
import decimal_precision as dp


#this code must be in  stock.py
class stock_production_lot(osv.osv):

    _inherit = 'stock.production.lot'
   
    
    def _calc_lot_area(self, l, h, w):
        obj_uom = self.pool.get('product.uom')
        r = obj_uom._calc_area(l,h)
        if w:
           r = obj_uom._calc_area(r,w)           
        return r
    

    def _calc_lot_factor(self, cr, uid, ids, name, arg, context=None):
        if context is None:
            context = {}
        if not len(ids):
            return []            
        res = {}
        for id in ids:
            # creates a UOM model to calculate lot factor
            r_brw = self.browse(cr, uid, id, context)    
            res[id] = self._calc_lot_area(r_brw.length, r_brw.heigth, r_brw.width)
#            obj_uom = self.pool.get('product.uom')
#            r = self.read(cr, uid, id, ['length','heigth','width'], context)    
#            res[id] = obj_uom._calc_area(r['length'],r['heigth'])
#            if r['width']:
#                res[id] = obj_uom._calc_area(res[id],r['width'])           
        return res
        
        
    def on_change_size(self, cr, uid, ids, length, heigth, width):
        res = {'value':{'lot_factor':self._calc_lot_area(length, heigth, width)}}
        return res
        
    #~ PORQUE EL ESTA DICIENDO QUE NO USEMOS ESTE CAMPO Y USEMOS WAREHOUSE QUE 
    #~ ES LO QUE SE QUIERE CON ELLO
    _columns = {
        'length': fields.float('Length (m)', digits_compute=dp.get_precision('Extra UOM data')),
        'width': fields.float('Width (m)', digits_compute=dp.get_precision('Extra UOM data')),
        'heigth': fields.float('Heigth (m)', digits_compute=dp.get_precision('Extra UOM data')),
#        'lot_location': fields.char('Location', size=10, translate=True), # don't use this field use wharehouse
        'lot_factor': fields.function(_calc_lot_factor, method=True, type="float", string='Lot Factor', digits_compute=dp.get_precision('Product UoM')),
    }
    
    
    _defaults = {
        'length':0.0,
        'width' :0.0,
        'heigth':0.0,
    }
        
        
    _sql_constraints = [
        ('length_gt_zero', 'CHECK (length>=0)', 'The length must be >= 0!'),
        ('width_gt_zero', 'CHECK (width>=0)', 'The width must be >= 0!'),
        ('heigth_gt_zero', 'CHECK (heigth>=0)', 'The heigth must be >= 0!'),
    ]


    def name_get(self,cr, uid, ids, context):
        if not len(ids):
            return []
#        reads = self.read(cr, uid, ids, ['id','name', 'prefix', 'ref','length','heigth','width','lot_factor','move_ids'], context)
        reads = self.browse(cr, uid, ids, context)
#        l = self.pool.get('stock.production.lot').browse(cr,uid,ids)
        res = []
        for r in reads:
            #TODO optimize with only one read for all ids, or maybe use "self" data
            l = self.pool.get('stock.production.lot').browse(cr,uid,r['id'])
            drv = l.product_id.stock_driver
            if drv == 'tile':
                name = '%s (%sx%s)' % (r.name.strip(),r.length,r.heigth)
            elif drv == 'slab':
                name = '%s (%sx%s)' % (r.name.strip(),r.length,r.heigth)
            elif drv == 'block':
                name = '%s (%sx%sx%s)' % (r.name.strip(),r.length,r.heigth,r.width)
            else: # call inherited name_get()
                this_id = [r.id]
                super_name = super(stock_production_lot,self).name_get(cr, uid, this_id, context)
                name = super_name[0][-1]
            res.append((r.id, name))
        return res
stock_production_lot()

# IMPORTANTE:
# En sale_order se debe incorporar una validacion que impida vender un lote parcial si el stock_driver es slab o block

#class sale_order(osv.osv):
#    _inherit = 'sale.order.line'
#    _columns = {
#        'prodlot_id' : fields.many2one('stock.production.lot', 'Production lot', help="Production lot is used to put a serial number on the production"),
#    }
#sale_order()
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

