# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from osv import fields,osv
import decimal_precision as dp
from tools.translate import _




class product_product_features(osv.osv):
    
    _name = 'product.product.features'
    
    _columns = {
        'name':fields.char('Name',128,required=True),
        'type':fields.selection([('layout','Layout'),('quality','Quality'),('material','Material'),('color','Color'),('finish','Finish')],'Type',  required = True),
    
    }
    _defaults = {
        'name': lambda *a: None,
        'type': lambda *a: 'layout',
    }
    
    
product_product_features()

class product_product_tile_format(osv.osv):
    """
    OpenERP Model : product_product_finish
    """
    
    _name = 'product.product.tile.format'
    _description = __doc__
    
#    def _calc_name(self, cr, uid, ids, name, arg, context=None):
#        if context is None:
#            context = {}
#        if not len(ids):
#            return []            
#        res = []
#        for id in ids:
#            r = self.read(cr, uid, id, [], context)    
#            print r
#            name = '(%sx%s)' % (r['length']+100,r['heigth']*100)
#            res.append((r['id'], name))
#        return res
    
    #TODO el campo name no se necesita pero si no se pone da error 
    #TODO probablemente la solucion sea crear name como campo function en lugar de usar el get_name
    _columns = {
        'name':fields.char('Tile format', size=16, required=False, readonly=True),
#        'name': fields.function(_calc_name, method=True, type="string", string='Format'),

        'length': fields.float('Length (m)', digits_compute=dp.get_precision('Extra UOM data')),
        'heigth': fields.float('Heigth (m)', digits_compute=dp.get_precision('Extra UOM data')),
        'kit':fields.boolean('Is kit')
    }
    _defaults = {
        'length': lambda *a: 0,
        'heigth': lambda *a: 0,
        'kit': lambda *a: False,
    }

    def name_get(self,cr, uid, ids, context):
        if not len(ids):
            return []
        reads = self.read(cr, uid, ids, [], context)
        res = []
        for r in reads:
            name = '(%s x %s) cm' % (r['length']*100,r['heigth']*100)
            res.append((r['id'], name))
        return res
product_product_tile_format()


class product_product_pricelist_group(osv.osv):
    """
    OpenERP Model : product_product_pricelist_group
    """
    
    _name = 'product.product.pricelist.group'
    _description = __doc__
    
    _columns = {
        'name':fields.char('Pricelist group', size=64, required=False, readonly=False),
    }
    _defaults = {
        'name': lambda *a: None,
    }
product_product_pricelist_group()


class product_product(osv.osv):
    # TODO product.procudt or product.template 
    _inherit = 'product.product'

    _columns = {
        'stock_driver' : fields.selection([('normal','Normal'),('tile','Tile'),('slab', 'Slab'), ('block', 'Block')], 'Stock driver', required=True, 
            help='This field set the internal metod to handle stock'),
        'material_id': fields.many2one('product.product.features', 'Material', domain=[('type','=','material')]),
        'layout_id': fields.many2one('product.product.features', 'Layout', domain=[('type','=','layout')]),
        'color_id': fields.many2one('product.product.features', 'Color', domain=[('type','=','color')]),
        'quality_id': fields.many2one('product.product.features', 'Quality', domain=[('type','=','quality')]),
        'finish_id': fields.many2one('product.product.features', 'Finish', domain=[('type','=','finish')]),
        'tile_format_id': fields.many2one('product.product.tile.format', 'Tile format'),
        'thickness':fields.integer('Thickness (mm)'),
        'pricelist_group_id': fields.many2one('product.product.pricelist.group', 'Pricelist group'),
        'origin_country_id': fields.many2one('res.country', 'Country of Origin'),
        'similarity_ids': fields.many2many('product.product', 'rel_product_product_similarity', 'product_id1', 'product_id2', 'Similar products')
#        TODO incorporar siglas (para las 6 letras del codigo) [GRILEO] GRIS LEONA 
        }
        
    _defaults = {
        'stock_driver' : lambda *a : 'normal',
        'thickness': lambda *a : 0,
    }
    
    _sql_constraints = [
        ('thickness_gt_zero', 'CHECK (thickness>=0)', 'The thickness must be >= 0!'),
#        ('volume_gt_zero', 'CHECK (volume>=0)', 'The volume must be >= 0!'),
#        ('weight_gt_zero', 'CHECK (weight>=0)', 'The weight must be >= 0!'),
#        ('weight_net_gt_zero', 'CHECK (weight_net>=0)', 'The net weight must be >= 0!'),
    ]

    
product_product()
            

class product_uom(osv.osv):
    _inherit = 'product.uom'
    
#    def _compute_qty(self, cr, uid, from_uom_id, qty, to_uom_id=False):
##        print '_compute_qty: %s' % (qty)
##TODO: Sentencia IF que verifica si debo usar el estandard o el personalizado.
#        return super(product_uom,self)._compute_qty(cr, uid, from_uom_id, qty, to_uom_id)

#    def _compute_qty_obj(self, cr, uid, from_unit, qty, to_unit, context=None):
##        print '_compute_qty_obj: %s % s' % (from_unit.name, to_unit.name)
#        return super(product_uom,self)._compute_qty_obj(cr, uid, from_unit, qty, to_unit, context)

#    def _compute_price(self, cr, uid, from_uom_id, price, to_uom_id=False):
##        print '_compute_price: %s' % (price)
#        return super(product_uom,self)._compute_price(cr, uid, from_uom_id, price, to_uom_id)

    # New metods for area calculation
    def _calc_area(self,f1,f2):
        '''Calculates an truncate f1*f2, set 4 decimal places
           No error check'''
        return int(f1*f2*10000)/10000.0   
        
    def _compute_area_tile(self, cr, uid, pieces, length, heigth, context=None):
        return self._calc_area(pieces,self._calc_area(length,heigth))
            
    def _compute_area_slab(self, cr, uid, length, heigth, context=None):
        return self._calc_area(length,heigth)
    
    def _compute_area_block(self, cr, uid, length, heigth, width, context=None):
        return self._calc_area(width,self._calc_area(length,heigth))
        
    def _compute_area(self, cr, uid, driver, pieces, length, heigth, width, context=None):
        #TODO check all values for inconsistencies f.ex length=None
        if driver   == 'tile':
            return self._compute_area_tile(cr, uid, pieces, length, heigth)
        elif driver == 'slab':    
            return self._compute_area_slab(cr, uid, length, heigth)
        elif driver == 'block':       
            return self._compute_area_block(cr, uid, length, heigth, width)
        else:
            raise osv.except_osv(_('Error'), _('Unkoun stock driver (%s): %s')%('product_uom._compute_area',driver,))

    # New metods for pieces calculation
    def _compute_pieces(self, cr, uid, driver, area, lot_factor, context=None):
        if driver   == 'tile':
            return lot_factor and int(area / lot_factor)
        elif driver in ('slab','block'):
            return 1 #In slab y block allways pieces = 1
        else:
            raise osv.except_osv(_('Error'), _('Unkoun stock driver (%s): %s')%('product_uom._compute_pieces',driver,))
    
product_uom()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
