# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from osv import fields,osv
import decimal_precision as dp
import netsvc
from tools.translate import _

class purchase_order_line(osv.osv):
    
   
    def product_id_change(self, cr, uid, ids, pricelist, product, qty, uom, partner_id, date_order=False, fiscal_position=False, date_planned=False, name=False, price_unit=False, notes=False):
        '''
        This method loads the withholding concept to a product automatically
        '''        
        res = super(purchase_order_line, self).product_id_change(cr, uid, ids, pricelist, product, qty, uom, partner_id, date_order, fiscal_position, date_planned, name, price_unit, notes)
        if product:
            product_obj = self.pool.get('product.product')
            produc_brw = product_obj.browse(cr,uid,product)
            res['value']['track_incoming']=produc_brw.track_incoming
        else:
            res['value']['track_incoming']= False
        print 'ESTO ES EEL ONCHANGE DE PRODUCT OUM EXTRZA'
        
        return res
   
      
    def on_change_qty(self,cr,uid,ids,product_id,id_lot,context=None):
        if not context:
            context = {}
        res = {'value': {}}
        
        if id_lot and product_id:
            spl_obj = self.pool.get('stock.production.lot')
            spl_brw = spl_obj.browse(cr,uid,id_lot)
            pieces = self.on_change_piece(cr,uid,ids,product_id,id_lot,context=None)
            res['value'].update({'pieces':pieces})
            res['value'].update({'product_uom_qty':pieces*spl_brw.lot_factor})
        return res

    def on_change_piece(self,cr,uid,ids,product_id,id_lot,context=None):
        if not context:
            context = {}
        stock_obj = self.pool.get('stock.production.lot')
        if id_lot and product_id:
            lot_brw = stock_obj.browse(cr,uid,id_lot)
            print "lot_Factor",lot_brw.lot_factor
            print "stock_available",lot_brw.stock_available
            
            return lot_brw.lot_factor and int(lot_brw.stock_available/lot_brw.lot_factor) or 0
  
  
           
    # TODO product.procudt or product.template 
    _inherit = 'purchase.order.line'

    _columns = {
                'prod_lot_id':fields.many2one('stock.production.lot','Production lot'),
                'pieces':fields.integer('Pieces',require=True),
                'track_incoming':fields.boolean('Track Incoming Lot'),
                }
    # TODO agregar validacion para requerir el nro de lote (track_outgoing)

   
    
purchase_order_line()   




class purchase_order(osv.osv):
    
    _inherit = 'purchase.order'
    
    def inv_line_create(self, cr, uid, a, ol):
        ''' 
        This method adds the withholding concept to an invoice.
        '''
        data = super(purchase_order, self).inv_line_create(cr, uid, a, ol)
        data[2]['prod_lot_id'] = ol.prod_lot_id and ol.prod_lot_id.id
        data[2]['pieces'] = ol.pieces
        data[2]['track_incoming'] = ol.track_incoming
        return data

    def action_picking_create(self,cr, uid, ids, *args):
        picking_id = False
        for order in self.browse(cr, uid, ids):
            loc_id = order.partner_id.property_stock_supplier.id
            istate = 'none'
            if order.invoice_method=='picking':
                istate = '2binvoiced'
            pick_name = self.pool.get('ir.sequence').get(cr, uid, 'stock.picking.in')
            picking_id = self.pool.get('stock.picking').create(cr, uid, {
                'name': pick_name,
                'origin': order.name+((order.origin and (':'+order.origin)) or ''),
                'type': 'in',
                'address_id': order.dest_address_id.id or order.partner_address_id.id,
                'invoice_state': istate,
                'purchase_id': order.id,
                'company_id': order.company_id.id,
                'move_lines' : [],
            })
            todo_moves = []
            for order_line in order.order_line:
                if not order_line.product_id:
                    continue
                if order_line.product_id.product_tmpl_id.type in ('product', 'consu'):
                    dest = order.location_id.id
                    move = self.pool.get('stock.move').create(cr, uid, {
                        'name': order.name + ': ' +(order_line.name or ''),
                        'product_id': order_line.product_id.id,
                        'product_qty': order_line.product_qty,
                        'product_uos_qty': order_line.product_qty,
                        'prodlot_id':order_line.prod_lot_id.id,
                        'pieces':order_line.pieces,
                        'product_uom': order_line.product_uom.id,
                        'product_uos': order_line.product_uom.id,
                        'date': order_line.date_planned,
                        'date_expected': order_line.date_planned,
                        'location_id': loc_id,
                        'location_dest_id': dest,
                        'picking_id': picking_id,
                        'move_dest_id': order_line.move_dest_id.id,
                        'state': 'draft',
                        'purchase_line_id': order_line.id,
                        'company_id': order.company_id.id,
                        'price_unit': order_line.price_unit
                    })
                    if order_line.move_dest_id:
                        self.pool.get('stock.move').write(cr, uid, [order_line.move_dest_id.id], {'location_id':order.location_id.id})
                    todo_moves.append(move)
            self.pool.get('stock.move').action_confirm(cr, uid, todo_moves)
            self.pool.get('stock.move').force_assign(cr, uid, todo_moves)
            wf_service = netsvc.LocalService("workflow")
            wf_service.trg_validate(uid, 'stock.picking', picking_id, 'button_confirm', cr)
        return picking_id
purchase_order()     
    
