# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from osv import fields,osv
import decimal_precision as dp
from tools.translate import _

class sale_order_line(osv.osv):
    
    def invoice_line_create(self, cr, uid, ids, context={}):
        create_ids = super(sale_order_line, self).invoice_line_create(cr, uid, ids, context)
        invoice_line_brws = self.pool.get('account.invoice.line').browse(cr, uid, create_ids)
        order_line_sale_brws = self.browse(cr, uid, ids)
        for line_invoice in invoice_line_brws: #lineas de la factura
            for line_sale in order_line_sale_brws: #lineas de la orden de venta
                if line_sale.product_id==line_invoice.product_id: #si es la misma linea 
                    self.pool.get('account.invoice.line').write(cr, uid, line_invoice.id, {'prod_lot_id':line_sale.prod_lot_id.id,'pieces':line_sale.pieces,'track_outgoing':line_sale.track_outgoing}) 
        return create_ids 
    
        
    
    
    def product_id_change(self, cr, uid, ids, pricelist, product, qty=0,uom=False, qty_uos=0, uos=False, name='', partner_id=False,lang=False, update_tax=True, date_order=False, packaging=False, fiscal_position=False, flag=False):

        res = super(sale_order_line, self).product_id_change(cr, uid, ids, pricelist, product, qty,uom, qty_uos, uos, name, partner_id,lang, update_tax, date_order, packaging, fiscal_position, flag)
        if product:
            product_obj = self.pool.get('product.product')
            produc_brw = product_obj.browse(cr,uid,product)
            res['value']['track_outgoing']=produc_brw.track_outgoing
        else:
            res['value']['track_outgoing']= False
        
        return res

   
   
   
   
    def on_change_qty(self,cr,uid,ids,product_id,id_lot,context=None):
        if not context:
            context = {}
        res = {'value': {}}
        
        if id_lot and product_id:
            spl_obj = self.pool.get('stock.production.lot')
            spl_brw = spl_obj.browse(cr,uid,id_lot)
            pieces = self.on_change_piece(cr,uid,ids,product_id,id_lot,context=None)
            res['value'].update({'pieces':pieces})
            res['value'].update({'product_uom_qty':pieces*spl_brw.lot_factor})
        return res

    def on_change_piece(self,cr,uid,ids,product_id,id_lot,context=None):
        if not context:
            context = {}
        stock_obj = self.pool.get('stock.production.lot')
        if id_lot and product_id:
            lot_brw = stock_obj.browse(cr,uid,id_lot)
            
            return lot_brw.lot_factor and int(lot_brw.stock_available/lot_brw.lot_factor) or 0
           
    # TODO product.procudt or product.template 
    _inherit = 'sale.order.line'

    _columns = {
                'prod_lot_id':fields.many2one('stock.production.lot','Production lot'),
                'pieces':fields.integer('Pieces',require=True),
                'track_outgoing':fields.boolean('Track Outgoing Lot'),
                }
    # TODO agregar validacion para requerir el nro de lote (track_outgoing)

   
    
sale_order_line()    

class sale_order(osv.osv):
    
    def action_ship_create(self, cr, uid, ids, *args):
        result = super(sale_order, self).action_ship_create(cr, uid, ids, *args)
        for order in self.browse(cr, uid, ids, context={}):
            for ol in order.order_line:
                for sm in ol.move_ids:
                    self.pool.get('stock.move').write(cr, uid, sm.id, {
                'prodlot_id':ol.prod_lot_id and ol.prod_lot_id.id,'pieces_qty':ol.pieces})
        return result
   
    _inherit = 'sale.order'
    

   
    

sale_order()


