# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from osv import fields,osv
import decimal_precision as dp

class stock_move(osv.osv):
    _inherit = 'stock.move'
    
    def _compute_pieces(self, cr, uid, ids, name, arg, context=None):
        move = self.browse(cr, uid, ids)        
        res = {}
        for m in move:
            if m.product_id.stock_driver in ('tile','slab','block'):
                uom = self.pool.get('product.uom')
                pieces = uom._compute_pieces(cr, uid, m.product_id.stock_driver, m.product_qty, m.prodlot_id.lot_factor, context)
                res[m.id] = pieces
            else:          
                res[m.id] = 0               
        return res
    
    _columns = {
        'pieces_qty': fields.function(_compute_pieces, method=True, type="integer", string='Pieces'),
    }

stock_move()


class stock_inventory_line(osv.osv):
    """
    stock_inventory_line
    """
    
    def _compute_pieces(self, cr, uid, ids, name, arg, context=None):
        line = self.browse(cr, uid, ids)        
        res = {}
        for l in line:
            if l.product_id.stock_driver in ('tile','slab','block'):
                uom = self.pool.get('product.uom')     
                pieces = uom._compute_pieces(cr, uid, l.product_id.stock_driver, l.product_qty, l.prod_lot_id.lot_factor, context)
                res[l.id] = pieces
            else:          
                res[l.id] = 0               
        return res
    
    _inherit = 'stock.inventory.line'

    _columns = {
        'pieces_qty': fields.function(_compute_pieces, method=True, type="integer", string='Pieces'),
    }
    
stock_inventory_line()

class stock_picking(osv.osv):
    _inherit = 'stock.picking'
      
    def _invoice_line_hook(self, cr, uid, move_line, invoice_line_id):
        ail_obj = self.pool.get('account.invoice.line')
        ail_obj.write(cr,uid,invoice_line_id,{'prod_lot_id':move_line.prodlot_id and move_line.prodlot_id.id,'pieces':move_line.pieces_qty},context=None)
        return super(stock_picking,self)._invoice_line_hook(cr, uid, move_line, invoice_line_id)
    
stock_picking()


