# -*- coding: utf-8 -*-

import urllib
from xml.dom.minidom import parseString
import time

__autor__ = "Alexander Olivares"
__email__ = "olivaresa@gmail.com"
__date__ = "2010-04-22"
__url__="http://siv.cenditel.gob.ve/svn/sigesic/ramas/sigesic-1.1.x/sigesic/apps/comun/seniat.py"
#Actualización 
__autor2__ = "Juan Márquez"
__email2__ = "jmarquez@tecvemar.com.ve"
__date2__ = "2011-08-30"
# Nuevas porpiedades y metodos:
#   self.porcentajeRET
#   def __load_url(self,retries,url):
#   def str_info_seniat(self):
#   def buscar_ci(self,ci):

class Seniat:
    """
    from seniat import Seniat
    r = Seniat()
    
    if r.buscar_rif('V1193389744'):
        print r.nombre
        print r.rif
        print r.agenteRetencionIVA
        print r.contribuyenteIVA

    if r.buscar_rif(r.buscar_ci('10332038')):
        print r.str_info_seniat()

    """
    
    def __init__(self):
        self.rif = '' 
        self.nombre = ''
        self.agenteRetencionIVA = ''
        self.contribuyenteIVA = ''
        self.porcentajeRET = 0.0


    def buscar_rif(self,rif=''):
        if rif:
            return self.__buscar(rif)
            
            
    def __load_url(self,retries,url):
        while retries > 0:
            try:
                s = urllib.urlopen(url)
                r = s.read()
                ok = not('404 Not Found' in r)
                if ok:
                    return r
            except:
                pass
            retries -= 1   
        return None                                     


    def __buscar(self,rif):
        try:
#            s = urllib.urlopen("http://contribuyente.seniat.gob.ve/getContribuyente/getrif?rif=%s" % rif)
#            xml_data = s.read()
            xml_data = self.__load_url(5,"http://contribuyente.seniat.gob.ve/getContribuyente/getrif?rif=%s" % rif)
            dom = parseString(xml_data)
            self.rif = rif
            self.nombre = dom.childNodes[0].childNodes[0].firstChild.data 
            self.agenteRetencionIVA = dom.childNodes[0].childNodes[1].firstChild.data 
            self.contribuyenteIVA = dom.childNodes[0].childNodes[2].firstChild.data 
            self.porcentajeRET = self.__buscar_porcentaje(rif)
            return True
        except Exception, e:
            self.rif = '' 
            self.nombre = ''
            self.agenteRetencionIVA = ''
            self.contribuyenteIVA = ''
            error = str(e)
            if error.find("Name or service not known") >=0:
                return "sin red"
            else:
                return False
                
                
    def __buscar_porcentaje(self,rif):
        try:
#            s = urllib.urlopen("http://contribuyente.seniat.gob.ve/BuscaRif/BuscaRif.jsp?p_rif=%s" % rif)
#            html_data = s.read()
            html_data = self.__load_url(5,"http://contribuyente.seniat.gob.ve/BuscaRif/BuscaRif.jsp?p_rif=%s" % rif)
            html_data = unicode(html_data, 'ISO-8859-1').encode('utf-8')
            search_str='La condición de este contribuyente requiere la retención del '
            pos = html_data.find(search_str)
            if pos > 0:
                pos += len(search_str)
                pct = html_data[pos:pos+4].replace('%','').replace(' ','')
                return float(pct)
            else:
                return 0.0    
        except Exception, e:
            error = str(e)
            if error.find("Name or service not known") >=0:
                return "sin red"
            else:
                return 0.0

                
    def str_info_seniat(self):
        if self.rif:
            return """
Resultado de la consulta en seniat.gob.ve:
   RIF: %s
   Nombre: %s
   Es agente de retencion IVA: %s
   Es contribuyente del IVA: %s
   El porcentaje de retencion a aplicar es: %s"""%(self.rif,self.nombre,self.agenteRetencionIVA,self.contribuyenteIVA,self.porcentajeRET)
        else:
            return ''
            

    def buscar_ci(self,ci):
        if ci:
            ci = ci.replace('V','')
#            s = urllib.urlopen("http://contribuyente.seniat.gob.ve/BuscaRif/BuscaRif.jsp?p_cedula=%s" % ci)
#            html_data = s.read()
            html_data = self.__load_url(5,"http://contribuyente.seniat.gob.ve/BuscaRif/BuscaRif.jsp?p_cedula=%s" % ci)        
            html_data = unicode(html_data, 'ISO-8859-1').encode('utf-8')
            if 'No existe el contribuyente solicitado' in html_data:
                return None
            search_str='<b><font face="Verdana" size="2">'
            pos = html_data.find(search_str)
            if pos > 0:
                pos += len(search_str)
                rif = html_data[pos:pos+10]
                return rif


