# -*- encoding: utf-8 -*-     
# ojo con las librerias: validar_rif y pymssql
from osv import osv
from osv import fields
from tools.translate import _
import logging
logger = logging.getLogger('server')
from validar_rif import Seniat
val_rif = Seniat()
import pymssql
import tools_dll 

#TODO Buscar una manera de separar cada modelo en una unidad diferente

companies = ({'id':0,'name':'Tecvemar',    'ip_addr':'192.168.0.1','db_name_adm':'TCVMR_A', 'db_name_cont':'TCVMR_A','co_cli':'TCV'},
             {'id':1,'name':'Barcelona',   'ip_addr':'192.168.1.1','db_name_adm':'ACROPOLI','db_name_cont':'','co_cli':'13121'},
             {'id':2,'name':'Guayana',     'ip_addr':'192.168.2.1','db_name_adm':'ACROGUAA','db_name_cont':'','co_cli':'13132'},
             {'id':3,'name':'Monagas',     'ip_addr':'192.168.3.1','db_name_adm':'ACROMOA', 'db_name_cont':'','co_cli':'13160'},
             {'id':4,'name':'Valencia',    'ip_addr':'192.168.4.1','db_name_adm':'DACRO_A', 'db_name_cont':'','co_cli':'28147'},
             {'id':5,'name':'Maracay',     'ip_addr':'192.168.5.1','db_name_adm':'ACMARA_A','db_name_cont':'','co_cli':'13165'},
             {'id':6,'name':'Barquisimeto','ip_addr':'192.168.6.1','db_name_adm':'ACBARQ_A','db_name_cont':'','co_cli':'13177'},
             {'id':7,'name':'Falcón',      'ip_addr':'192.168.7.1','db_name_adm':'ACFALC_A','db_name_cont':'','co_cli':'13195'})
             
country_id_vzla = 0 # el valor se asigna en import_button_click
unkouwn_location = 0
#1354 #DONE muy cableado usar un search ilike

class message_end(osv.osv_memory):
    """
    OpenERP osv memory wizard : message_end
    """
    
    _name = 'message.end'
    _description = __doc__
    
    _columns = {
        'name':fields.text('Atención:', size=64, readonly=True),
    }
    _defaults = {
        'name': lambda *a: "Se ha completado el proceso de importacion exitosamente.",
    }
message_end()
               
               
class profit_db_data():
    def __init__(self,host,user,password,database):               
        self.host = host
        self.user = user
        self.password = password
        self.database = database
        self.conn = pymssql.connect(host=self.host, user=self.user, password=self.password, database=self.database , as_dict = True)
        self.cur = self.conn.cursor()
        
        
    def execsql(self,sql,params=''):
        if params:
            return self.cur.execute(sql % params)
        else:
            return self.cur.execute(sql)
            
            
    def str_import(self,s):
        """
        This function "clean" the strings imported from profit
        """
        if s:
            s = s.replace(chr(10),' ')
            s = s.replace(chr(13),' ')
            s = s.replace('  ',' ')
            s = s.replace('\n','')
            s = s.replace('\t','')
            s = s.strip()
        if s:    
            s = unicode(s, 'latin-1').encode('utf-8')
            s = s.replace('','€')
        return s
        
        
    def str_rif(self,s):
        """Basic RIF string cleaning"""
        s = self.str_import(s)
        if s:
            s = s.replace(' ','')
            s = s.replace('-','')
            s = s.replace('.','')
            s = s.capitalize()
        return s      

    def close(self):   
        self.conn.close()
    
# class snnipet
class tcv_profit(osv.osv_memory):
    """
    OpenERP osv memory wizard : tcv_profit
    """
    _name = 'tcv.profit'
    _description = """This module works with profit (2k8 corporativo)"""
    
    
    _columns = {
        'company_id': fields.many2one('res.company', 'Company', required=True),
        'username':fields.char('Username', size=16, required=False, readonly=False),
        'password':fields.char('Password', size=16, required=False, readonly=False),
        'import_model':fields.selection([
            ('res_company','Res company'),
            ('account_payment_term','Account payment term'),
            ('account_journal','Account journal'),
            ('product_category','Product Category'),
            ('stock_inventory','Stock inventory'),
            ('res_partner','Res partner'),
            ('res_partner_title','Res partner title'),
#            ('product_category','Product categories'),
            ('stock_location','Stock Location'),
#            ('products','Res Products'),
#            ('all','All Tables...'),
            ('res_partner_accounts','Create partner accounts'),
            ],'Table to import:', select=True, readonly=False, required=True),
        }

    
    _defaults = {
        'company_id': lambda s,cr,uid,c: s.pool.get('res.company')._company_default_get(cr, uid, 'account.account', context=c),
        'username': lambda *a: 'profit',
        'password': lambda *a: 'profit',
        'import_model': lambda *a: 'res_partner_accounts',
        }

        
    def __company_id(self,cr, uid, ids, context=None):
        return self.read(cr, uid, ids, ['company_id'],context=context)[0]['company_id']

    
    def __get_profit_server(self,company_id):
        global companies
        for s in companies:
            if s['id'] == company_id:
                return s
                
                
    def __profit_id(self,cr, uid, company_id, context=None):
        obj_company = self.pool.get('res.company')
        obj_partner = self.pool.get('res.partner')
        partner_id = obj_company.read(cr, uid, [company_id], ['partner_id'],context=context)[0]['id']
        ref = obj_partner.read(cr, uid, [partner_id], ['ref'],context)[0]['ref']
        for c in companies:
            #print '[%s] %s=%s'%(partner_id, c['co_cli'],ref)
            if c['co_cli'] == ref:
                return c['id']


    def __profit_db_adm(self,cr, uid, ids, context=None):
        data = self.read(cr, uid, ids, [],context=context)[0]
        profit_id = self.__profit_id(cr, uid, data['company_id'], context)
        usr = data['username']
        pwd = data['password']
        #~ print '%s %s %s %s'%(companies[profit_id]['ip_addr'],usr,pwd,companies[profit_id]['db_name_adm'])
        return profit_db_data(companies[profit_id]['ip_addr'],usr,pwd,companies[profit_id]['db_name_adm'])

                
    def __get_country_id(self,cr,uid,code):
        obj_res_country = self.pool.get('res.country')
        ids = obj_res_country.search(cr,uid,[('code', '=', code)])
        if len(ids) == 0 or len(ids) > 1:
           return country_id_vzla #Venezuela
        else:   
           return ids[0]    
           
        
    def __unkouwn_location(self,cr, uid, context=None):
        global unkouwn_location
        if not unkouwn_location:
            obj_location = self.pool.get('stock.location')
            unkouwn_location = obj_location.search(cr, uid, [('name', '=', 'Indeterminada')])[0]
        return unkouwn_location
        
        
    def __progress_log(self,company_id,msg,max):
        global companies
        return {'step':5,
                'pos':0,
                'max':max,
                'msg':msg,
                'company':companies[company_id-1]['name'],
                }
                    
        
    def __progress_step(self,prg):
        prg['pos'] += 1
        if (prg['pos'] * 100 / prg['max']) >= prg['step']:
            logger.info('[%s] Profit data %s: %s%% loaded.'%(prg['company'],prg['msg'],prg['step']))
            prg['step'] += 5
        return prg    
            
            
#--------------------------------------------------------------------------------------------------Res company
    def update_main_company(self,cr,uid,ids,context,currency_id,country_id):
        global companies
        rif = 'J000360910'
        name = 'TECNICA MARMOLERA VENEZOLANA, C.A.'

        obj_company = self.pool.get('res.company')
        company = {}
        company['name'] = name
        company_id = [1]
        obj_company.write(cr, uid, company_id, company, context) 
        
        obj_partner = self.pool.get('res.partner')
        partner_id = [1]
        partner = obj_partner.read(cr, uid, partner_id, context)[0]
        # Cargar datos en el partner            
        partner = {'ref':'TCV',
                   'name':name, 
                   'vat':'VE'+rif,
                   'lang':'es_VE',
                   'customer':True,
                   'supplier':True,
                   'islr_whitholding_agent':True,
                   'wh_iva_agent':True,
                   'wh_iva_rate':True,
                   'currency_id':currency_id,
                  } 
#        obj_partner.write(cr, uid, partner_id, partner, context)
            # Cargar datos del address
#        obj_address = self.pool.get('res.partner.address')
        address = {
               'type' : 'invoice', 
#               'partner_id':partner_id[0],
               'name': 'Miguel Ruscino',
               'function':'Director',
               'street': 'Zona Industrial del Este, 1ra Avenida, Parcela F',
               'zip': '1220',
               'city': 'Guarenas',
               'phone': '212 362 5031 / 631 2668 / 361 0465',
               'fax': '212 362 3444',
               'email':'tecvemar@cantv.net',
               'country_id': country_id,
                }        
#        obj_address.create(cr, uid, address, context)
        partner['address'] = [(0,0,address)]
        obj_partner.write(cr, uid, partner_id, partner, context)  
    
    
    def import_res_company(self,cr,uid,ids,context=None):
        global companies
        logger.info('module tcv_profit: import: Res company...')
        currency_id = self.pool.get('res.currency').search(cr, uid, [('name', '=', 'VEB')])[0]
        country_id = self.pool.get('res.country').search(cr, uid, [('code', '=', 'VE')])[0]
        self.update_main_company(cr,uid,ids,context,currency_id,country_id)
        for c in range(1,len(companies)): #Saltar tecvemar 
            comp = companies[c]
            data = self.read(cr, uid, ids, [],context=context)[0]
            usr = data['username']
            pwd = data['password']
            # Leer datos desde tecvemar
            # Cableado usar __profit_db_adm
            obj_profit = profit_db_data(companies[0]['ip_addr'],usr,pwd,companies[0]['db_name_adm'])
            obj_profit.execsql("select * from clientes where co_cli = '%s'"%comp['co_cli'])
            data_profit = obj_profit.cur.fetchone()
            # Create the new company
            new_company = {'name':obj_profit.str_import(data_profit['cli_des']),
                           'currency_id':currency_id, }
            obj_company = self.pool.get('res.company')
            company_id = obj_company.create(cr, uid, new_company, context)      
            # Update extra partner data  
            obj_partner = self.pool.get('res.partner')
            partner_id = obj_partner.search(cr, uid, [('name', '=',new_company['name'])])
            partner = obj_partner.read(cr, uid, partner_id, context)[0]
            # Cargar datos en el partner            
            rif = obj_profit.str_rif(data_profit['rif'])
            # Validar datos fiscales contra el SENIAT
            val_rif.buscar_rif(rif)
            partner =  {'ref':obj_profit.str_import(data_profit['co_cli']),
                        'vat':'VE'+rif,
                        'lang':'es_VE',
                        'customer':True,
                        'supplier':True,
                        'comment':val_rif.str_info_seniat().encode('utf-8'),
                        'islr_whitholding_agent':True,
                        'wh_iva_agent':val_rif.agenteRetencionIVA == 'SI',  
                        'wh_iva_rate':val_rif.porcentajeRET,
                        'company_id':0, # Nuevo validar que sirva 2011 10 25
                        }
#            obj_partner.write(cr, uid, partner_id, partner, context)
            # Cargar datos del address
#            obj_address = self.pool.get('res.partner.address')
            address =  {'type' : 'invoice', 
                        'name': obj_profit.str_import(data_profit['respons']),
                        'function':'Gerente',
                        'street': obj_profit.str_import(data_profit['direc1']),
                        'zip': obj_profit.str_import(data_profit['zip']),
                        'city': obj_profit.str_import(data_profit['ciudad']).capitalize(),
                        'phone': obj_profit.str_import(data_profit['telefonos']),
                        'fax': obj_profit.str_import(data_profit['fax']),
                        'email':obj_profit.str_import(data_profit['email']),
                        'country_id': country_id,
                        }
#            obj_address.create(cr, uid, address, context)
            partner['address'] = [(0,0,address)]
            obj_partner.write(cr, uid, partner_id, partner, context)  
        logger.info('module tcv_profit: Res company. Done.')
         
         
#--------------------------------------------------------------------------------------------------Account payment term
    def import_account_payment_term(self,cr,uid,ids,context=None):

        terms = ('Contado','Consignación')

        logger.info('module tcv_profit: import: Account payment term...')
        obj_term = self.pool.get('account.payment.term')
        for t in terms:
            data = {'name':t}
            if not obj_term.search(cr,uid,[('name','=',t)]):
                obj_term.create(cr, uid, data, context)
        logger.info('module tcv_profit: Account payment term. Done.')
        

#--------------------------------------------------------------------------------------------------Account journal
    def __import_bank_journals(self, cr, uid, ids, company_id, obj_account_journal, currency_id, context=None):
        obj_profit_banks = self.__profit_db_adm(cr,uid,ids,context)
        obj_profit_banks.execsql('''select c.cod_cta, b.des_ban, c.num_cta, c.sucursal
                                    from cuentas c left join bancos b on c.co_banco = b.co_ban''')
        banks = obj_profit_banks.cur.fetchall() 
        c = 1
        for b in banks:
            data = {'code':'DB%003d'%(c), 
                    'name':'Diario / [%s] %s Cta: %s'%(obj_profit_banks.str_import(b['cod_cta']),obj_profit_banks.str_import(b['des_ban']),obj_profit_banks.str_import(b['num_cta'])), 
                    'type':'bank', 
                    'view_id':1,
                    'company_id':company_id,
                    'currency':currency_id,
                    }
            bj_id = obj_account_journal.search(cr,uid,[('code','=',data['code'])])
            if not bj_id: # new/ create
                obj_account_journal.create(cr, uid, data, context)
            else: #Update
                obj_account_journal.write(cr, uid, bj_id, data, context)
            c += 1    


    def import_account_journal(self,cr,uid,ids,context=None):
        journals = (
                    #Compras/Ventas
                    {'code':'DCN', 'name':'Diario / Compras Nacionales', 'type':'purchase', 'view_id':4, },
                    {'code':'DCIUS', 'name':'Diario / Compras Importación US$', 'type':'purchase', 'view_id':4, },
                    {'code':'DCIEU', 'name':'Diario / Compras Importación EUROS', 'type':'purchase', 'view_id':4, },
                    {'code':'DVE', 'name':'Diario / Ventas', 'type':'sale', 'view_id':4, },
                    # Medios de cobro
                    {'code':'DCEF', 'name':'Diario / Cobros Efectivo', 'type':'cash', 'view_id':1, },
                    {'code':'DCCH', 'name':'Diario / Cobros Cheque', 'type':'cash', 'view_id':1, },
                    {'code':'DCP01', 'name':'Diario / Cobros Punto de Venta', 'type':'cash', 'view_id':1, },
                    # Caja Chica
                    {'code':'DCCH', 'name':'Diario / Caja Chica', 'type':'cash', 'view_id':1, },
                    # Stocks
                    {'code':'DST', 'name':'Diario / Stocks', 'type':'general', 'view_id':3, },
                    # Nominas
                    {'code':'DNM', 'name':'Diario / Nominas', 'type':'general', 'view_id':3, },
                    # DONE Incorporar un diario por cada cta bancaria
                    )   
        # TODO Agregar divisa cuentas y demás datos            
        #~ for j in range(1,8):
            #~ print '%s- %s'%(j,self.__profit_id(cr, uid, j, context))
        currency_id = self.pool.get('res.currency').search(cr, uid, [('name', '=', 'VEB')])[0]
        logger.info('module tcv_profit: import: Account journal...')
        company_id = self.__company_id(cr, uid, ids, context)
        obj_account_journal = self.pool.get('account.journal')
        for aj in journals:
            data = aj
            data['company_id'] = company_id
            data['currency'] = currency_id
            aj_id = obj_account_journal.search(cr,uid,[('code','=',aj['code'])])
            if not aj_id: # new/ create
                obj_account_journal.create(cr, uid, data, context)
            else: #Update
                obj_account_journal.write(cr, uid, aj_id, data, context)
        # Las cuentas bancarias        
        self.__import_bank_journals(cr, uid, ids, company_id, obj_account_journal, currency_id, context)
        logger.info('module tcv_profit: Account journal. Done.')

        
#--------------------------------------------------------------------------------------------------Product category
    def import_product_category(self,cr,uid,ids,context):

        groups = ({'group_name':'Materia prima','items':('Bloques','Tiras','Insumos','Varios')},
                  {'group_name':'Producción Nacional','items':('Láminas','Baldosas','Spaccatos y Scapezzatos','Rodapies','Piezas especiales','Varios')},         
                  {'group_name':'Distribución','items':('Láminas','Baldosas','Cerámicas y Porcelanatos','Spaccatos y Scapezzatos','Mosaicos','Rodapies',
                                                        'Insumos','Lavamanos','Mastiques','Telas y Discos','Abrasivos','Varios')},         
                  {'group_name':'Otros','items':('Alquileres','Servicios','Máquinas, Fresas y Herramientas','Varios')},                                      
                  {'group_name':'Mantenimiento','items':('Repuestos','Varios')},                                      
                     )

#        ,'Producción Nacional','Distribución','Otros','Mantenimiento')  
        logger.info('module tcv_profit: import: Product category...')
        obj_product_category = self.pool.get('product.category')
        main_id = obj_product_category.search(cr,uid,[('name', '=', 'All products')])[0]
        # All products: type = 'view'
        new_product_category = {'type':'view',}
        obj_product_category.write(cr, uid, [main_id], new_product_category, context)                        
        for g in groups:
            new_product_category = {'name':g['group_name'],
                                    'parent_id':main_id,
                                    'type':'view',}
            id = obj_product_category.create(cr, uid, new_product_category, context)                        
            for i in g['items']:
                new_product_category = {'name':i,
                                        'parent_id':id,
                                        'type':'normal',}
                obj_product_category.create(cr, uid, new_product_category, context)                        
        # Productos sin Clasificar / Solo durante migración desde profit       
        new_product_category = {'name':'Sin clasificar',
                                'parent_id':0,
                                'type':'normal',}
        id = obj_product_category.create(cr, uid, new_product_category, context)                        
        logger.info('module tcv_profit: Product category. Done.')
        
        
        
#--------------------------------------------------------------------------------------------------stock_inventory
    def __empty_line(self,cr, uid, context,info):
        ''' returns a empty line '''
        empty_line = {'company_id':info['company_id'],
                      'product_id':info['product']['id'],
                      'name':'',
                      'length':0,
                      'heigth':0,
                      'width':0,
                      'ref':'',
                      'location_id': self.__unkouwn_location(cr, uid, context),
                      'product_qty':0,
                      'product_uom':0,
                      'prod_lot_id':0}
        return empty_line        

    def __new_stock_inventory(self, cr, uid, info, lines,  context=None):
        '''
        Esta función generica crea el movimiento, la linea de mov y el lote segun se requiera,
        debe indicarse una lista de diccionarios con los movimientos.
        Ver estructura de: __empty_line 
        '''
        # Create stock.inventory
        # Se coloco aqui para generar los inventarios con vacios y con errores
        obj_stock_inventory = self.pool.get('stock.inventory')
        new_stock_inv = {'company_id':info['company_id'],   
                         'name':info['name'],
                         'state':'draft', #TODO set state to Done.
                         }
        inventory_id = obj_stock_inventory.create(cr, uid, new_stock_inv, context)                 
        if len(lines) > 0: # Hay movimientos proceder
            for line in lines:
                if line['name'] <> '': 
                    # Create stock.production.lot
                    obj_stock_prod_lot = self.pool.get('stock.production.lot')
                    new_lot = {'company_id':line['company_id'],
                               'product_id':line['product_id'],
                               'name':line['name'],
                               'length':line['length'],
                               'heigth':line['heigth'],
                               'width':line['width'],
                               'ref':line['ref'],
                               } 
                    line['prod_lot_id'] = obj_stock_prod_lot.create(cr, uid, new_lot, context)
                # Create stock.inventory.line
                obj_stock_inv_line = self.pool.get('stock.inventory.line')
                new_line = {'company_id':line['company_id'],
                            'location_id':line['location_id'],
                            'product_id':line['product_id'],
                            'product_qty':line['product_qty'],
                            'product_uom':line['product_uom'],
                            'prod_lot_id':line['prod_lot_id'],
                            'inventory_id':inventory_id,
                            }
                line_id = obj_stock_inv_line.create(cr, uid, new_line, context)
                
                
    def __trans_uom(self,cr,uid,profit_uom):
        p_uom = ('CAJ','CAR','HILS','KG','ML','MT2','MT3','SAC','TON',  'UNI')
        o_uom = ('PCE','PCE','PCE', 'kg','ml','m2', 'm3', 'PCE','tonne','PCE') #TODO chequear conversion de todas las unidades
        openerp_uom = o_uom[p_uom.index(profit_uom.strip())]
        ids = self.pool.get('product.uom').search(cr, uid, [('name', '=', openerp_uom)])
        return ids[0] if len(ids) == 1 else 0
        
        
    def __profit_driver(self,info):
        ''' Esta funcion analiza la configuración del articulo en profit y
            determina el ID del metodo para transferir el inventario
            
            0. Desconocido no procesar (mostrar error en log)
            1. Inventario normal por unidades
            2. Usa lotes y medidas
            3. Usa lotes pero no medidas
        '''    
        if not info['usa_medidas']:
            if info['product']['stock_driver'] != 'normal':
                logger.error("""Stock driver must be 'normal' (%s):\n\t%s\n."""%(info['product']['stock_driver'],info['name']))
                return 0
#                raise osv.except_osv(_('Error'), _("""Stock driver must be 'normal' (%s):\n\t%s\n.""")%(info['stock_driver'],info['name']))    
            if not info['usa_lotes']: #productos normales
                if info['tipo_relac'] == 1: # no maneja unid. secun
                    if info['uom1'] in ('UNI', 'ML', 'KG'):
                        return 1    
                elif info['tipo_relac'] < 4 and info['factor_conv_und'] == 1: # Relac de Prim/secun ó Secum/prim pero con un factor de 1
                    if info['uom1'] == 'UNI':
                        return 1    
            else: #Producto normal con lotes !
                if info['tipo_relac'] == 1: # no maneja unid. secun
                    if info['uom1'] in ('UNI', 'ML', 'KG'): #
                        return 3     

                if info['tipo_relac'] == 3 and info['co_lin'] in ('SC','SP') and info['uom1'] == 'MT2':# Maneja relac secun->Prim
                    return 3  # caso especial de espacatos y escapezatos
        else:
            if info['product']['stock_driver'] == 'normal':
                logger.error("""Stock driver can't be 'normal':\n\t%s\n."""%(info['name']))
                return 0
#                raise osv.except_osv(_('Error'), _("""Stock driver can't be 'normal':\n\t%s\n.""")%(info['name']))    
            if info['usa_lotes']:
                if info['tipo_relac'] == 1: # no maneja unid. secun
                    if info['uom1'] in ('MT2','MT3'):
                        return 2
        return 0
        
        
    def __load_stock_1(self,cr,uid, info, obj_profit_stock): # carga el stock normal sin lotes
        obj_profit_stock.execsql("""select * from st_almac where stock_act > 0 and co_art = '%s'"""%(info['co_art']))
        stocks = obj_profit_stock.cur.fetchall()
        if len(stocks) > 1:
            logger.warning('Module tcv_profit: Inconsistent stock:')
        res = []  
        for s in stocks:
            l = self.__empty_line(cr, uid, None, info)
            l['product_qty'] = s['stock_act']
            l['product_uom'] = self.__trans_uom(cr,uid,info['uom1'])
            res.append(l)
        return res    


    def __load_stock_2(self,cr,uid, info, obj_profit_stock): # lotes con medidas 
        obj_profit_stock.execsql("""select l.co_art, l.nro_lote, s.stock_act, s.stock_com, l.aux02
                                    from lote l left join st_lote s on l.co_art = s.co_art and l.nro_lote = s.nro_lote
                                    where l.co_art = '%s' and s.stock_act > 0 --and s.stock_com = 0
                                    order by l.nro_lote"""%(info['co_art']))
        stocks = obj_profit_stock.cur.fetchall()
        res = []  
        obj_location = self.pool.get('stock.location')
        for s in stocks:
            l = self.__empty_line(cr, uid, None, info)
            aux02 = tools_dll.decode_aux02(obj_profit_stock.str_import(s['aux02']))
            l['name'] = s['nro_lote']
            l['length'] = aux02['length']
            l['heigth'] = aux02['heigth']
            if info['product']['stock_driver'] == 'block':
                l['width'] = aux02['width']
            stock_lote = tools_dll.stock_en_factores_a2(aux02)
            dif = abs(s['stock_act']-stock_lote)
            if s['stock_com'] == 0:
                l['ref'] = '%s - Ok'%(info['co_art']) if dif < 0.0025 else \
                    'error: a:%s s:%.4f d:%s'%(obj_profit_stock.str_import(s['aux02']),stock_lote,dif)
            else:
                l['ref'] = '%s (%s comp)'%(info['co_art'],s['stock_com'])
            loc_id = obj_location.search(cr, uid, [('name', '=', aux02['location'])])
            if len(loc_id) == 1:
                l['location_id'] = loc_id[0]
            l['product_qty'] = s['stock_act']
            l['product_uom'] = self.__trans_uom(cr,uid,info['uom1'])
            res.append(l)
        return res    


    def __load_stock_3(self,cr,uid, info, obj_profit_stock): # lotes sin medidas
        obj_profit_stock.execsql("""select l.co_art, l.nro_lote, s.stock_act, l.aux02
                                    from lote l left join st_lote s on l.co_art = s.co_art and l.nro_lote = s.nro_lote
                                    where l.co_art = '%s' and s.stock_act > 0 and s.stock_com = 0
                                    order by l.nro_lote"""%(info['co_art']))
        stocks = obj_profit_stock.cur.fetchall()
        res = []  
        obj_location = self.pool.get('stock.location')
        for s in stocks:
            l = self.__empty_line(cr, uid, None, info)
            l['name'] = s['nro_lote']
            l['product_qty'] = s['stock_act']
            l['product_uom'] = self.__trans_uom(cr,uid,info['uom1'])
            res.append(l)
        return res    


    def import_stock_inventory(self,cr,uid,ids,context=None):
        logger.info('module tcv_profit: import: stock inventory...')
        company_id = self.read(cr, uid, ids, [],context=context)[0]['company_id']
        origen_id = 0 # para forzar tecvemar
#        Conectar a DB profit
        #TODO User __profit_db_adm
        data = self.read(cr, uid, ids, [],context=context)[0]
        usr = data['username']
        pwd = data['password']
        obj_profit_stock = obj_profit_art = profit_db_data(companies[origen_id]['ip_addr'],usr,pwd,companies[origen_id]['db_name_adm'])
#        Read profit data: Art
#       Saltar Piezas especiales y tiras
        obj_profit_art.execsql("""select * from art where anulado = 0 and tipo <> 'S' and co_lin <> 'PE' and co_subl <> 'BT' order by co_art""")
        arts = obj_profit_art.cur.fetchall()
        prg = self.__progress_log(company_id,'stock inventory',len(arts))
        for art in arts:
#            Leer valores iniciales
            # para mostrar progreso
            prg = self.__progress_step(prg)
            #~ prg['pos'] += 1
            #~ if (prg['pos'] * 100 / prg['max']) >= prg['step']:
                #~ logger.info('Profit data: %s%% loaded.'%(prg['step']))
                #~ prg['step'] += 5
            co_art = obj_profit_art.str_import(art['co_art'])
            art_des = obj_profit_art.str_import(art['art_des'])
            name = '[%s] %s'%(co_art,art_des)
            sto_ids = self.pool.get('stock.inventory').search(cr,uid,[('name','=',name)])
            if not sto_ids: #Saltar si ya existe el inventario (no cargar duplicado
    #            Ubicar el artículo en OpenERP
                product_id = self.pool.get('product.product').search(cr, uid, [('default_code', '=', co_art)])
                if len(product_id) != 1:
                    logger.error('Unknown product:\n\t%s\nYou must update product list.'%(name))
#                    raise osv.except_osv(_('Error'), _('Unknown product:\n\t%s\nYou must update product list.')%(name))    
                else:
                    product_id = product_id[0]
                    product = self.pool.get('product.template').read(cr, uid, product_id, [])
                    product.update(self.pool.get('product.product').read(cr, uid, product_id, []))
        #            Buscar datos relacionados
                    uom_id = product['uom_id'][0]
                    #Inicializaciones
                    product_info = {'company_id':company_id,
                                    'co_art':co_art,
                                    'art_des':art_des,
                                    'name':name,
                                    'product':product,
                                    'uom1':art['uni_venta'].strip(),
                                    'uom2':art['suni_venta'].strip(),
                                    'uom3':art['tuni_venta'].strip(),
                                    'tipo_relac':art['relac_aut'],
                                    'factor_conv_und':art['uni_relac'],
                                    'usa_lotes':art['lote'],
                                    'usa_medidas':art['campo1'].upper().strip()=='X',
                                    'co_lin':art['co_lin'].upper().strip(),
                                   } 
                    product_info['profit_driver'] = self.__profit_driver(product_info)
                    new_lines = []
                    if product_info['profit_driver'] == 0:
                        logger.error('Module tcv_profit: Unknown inventory driver:\n\t%s'%(name))
                        product_info['name'] += '- ERROR DRV'
    #                    return False
    #                    raise osv.except_osv(_('Error'), _('Unknown inventory driver:\n\t%s')%(name))    
                    elif product_info['profit_driver'] == 1: 
                        new_lines = self.__load_stock_1(cr,uid,product_info,obj_profit_stock)                         
                    elif product_info['profit_driver'] == 2: 
                        new_lines = self.__load_stock_2(cr,uid,product_info,obj_profit_stock)                         
                    elif product_info['profit_driver'] == 3: 
                        new_lines = self.__load_stock_3(cr,uid,product_info,obj_profit_stock)                         

                    self.__new_stock_inventory(cr, uid, product_info, new_lines)  
        logger.info('module tcv_profit: stock_inventory. Done.')


#--------------------------------------------------------------------------------------------------Res partner
    def __create_partner(self, cr, uid, obj_res_partner, obj_profit, row, company_id, is_cust):
        # create new partner    
        # create the new address for partner
        address = {
           'type' : 'invoice',
           'name': obj_profit.str_import(row['respons']),
           'street': obj_profit.str_import(row['direc1']),
           'zip': obj_profit.str_import(row['zip']),
           'city': obj_profit.str_import(row['ciudad']).capitalize(),
           'phone': obj_profit.str_import(row['telefonos']),
           'fax': obj_profit.str_import(row['fax']),
           'country_id': self.__get_country_id(cr, uid, obj_profit.str_import(row['co_pais'])),
            }
        # Check RIF in SENIAT web page, save results in comment    
        info_rif = ''
        partner_active = True
        wh_iva_agent = False
        wh_iva_rate = 0.0
        rif = obj_profit.str_rif(row['rif'])
        # se deshabilito para pruebas por razones de velocidad
        if address['country_id'] == country_id_vzla: # Validar el RIF si el pais es Venezuela  (esta linea se queda no borrar)
            rif = 'VE%s'%(rif) #sólo esta linea debe quitarse para habilitar el codigo de verificación del rif
            #~ # para activar verificación del rif descomentar esta seccion y borrar linea anterior
            #~ if rif <> '': 
                #~ val_rif.buscar_rif(rif)
                #~ if val_rif.nombre == '' and len(rif) < 10: # no se encontró el rif probar buscar la ci
                    #~ rif = val_rif.buscar_ci(rif)
                    #~ val_rif.buscar_rif(rif)
                #~ info_rif = val_rif.str_info_seniat()
                #~ partner_active = bool(info_rif) # marcar como inactivos los patrner con error en el rif
                #~ rif = 'VE%s'%(rif)
                #~ if not partner_active:
                    #~ info_rif = 'Imposible verificar RIF: %s'%(rif)
                    #~ if len(rif) < 12:
                        #~ rif = ''
                #~ else:
                    #~ wh_iva_agent = val_rif.agenteRetencionIVA == 'SI'  
                    #~ wh_iva_rate = val_rif.porcentajeRET      
            #~ else:
                #~ info_rif = 'Rif en blanco'
                #~ partner_active = False
                    
        else:
            rif = row['rif']            
        partner = {
           'ref': obj_profit.str_import(row['co_cli']), 
           'vat': rif if rif != 'VENone' else '', 
           'name': obj_profit.str_import(row['cli_des']),
           'lang': 'es_VE',
           'customer': is_cust,
           'supplier': not(is_cust),
           'address':[(0,0,address)], 
           'comment': info_rif,
        #   'active':partner_active,
           'wh_iva_agent':wh_iva_agent, 
           'wh_iva_rate':wh_iva_rate,
           'vat_apply':True,
           'company_id':company_id,
            }
        if  partner['vat'] == None or len(partner['vat']) <> 12:
            partner['vat'] = ''    
        #~ print 'Partner: %s %s' % (partner['ref'],partner['name'])
        try:
            return obj_res_partner.create(cr, uid, partner)
        except:
            # TODO create log with errors
            print partner
            pass   


    def import_res_partner(self,cr,uid,ids,context=None):
        #DONE evaluar si realmente conviene reescribir el código actual (web-services): para res.partners SI.
        logger.info('module tcv_profit: import: Res partner...')
        company_id = self.read(cr, uid, ids, [],context=context)[0]['company_id']
        #~ origen_id = 0 # para forzar tecvemar
#        Conectar a DB profit
        top_limit = '' # top ###
        #~ data = self.read(cr, uid, ids, [],context=context)[0]
        #~ usr = data['username']
        #~ pwd = data['password']
        #~ obj_profit = profit_db_data(companies[origen_id]['ip_addr'],usr,pwd,companies[origen_id]['db_name_adm'])
        obj_profit = self.__profit_db_adm(cr,uid,ids,context)
        obj_res_partner = self.pool.get('res.partner')
#        Read profit data: Clientes
        obj_profit.execsql("""
            SELECT %s co_cli, cli_des, rif, direc1, ciudad, co_pais,
                   telefonos, fax, email, zip, respons 
            FROM clientes where campo3 != 'ACROPOLIS' Order by cli_des"""%(top_limit))
        cli_profit = obj_profit.cur.fetchall()
        logger.info('module tcv_profit: import: Res partner/Clientes...')
        prg=self.__progress_log(company_id,'Clientes',len(cli_profit))
        for cli in cli_profit:
            prg = self.__progress_step(prg)
            args = [('ref', '=', obj_profit.str_import(cli['co_cli'])),('company_id','=',company_id)] #query clause      
            ids = obj_res_partner.search(cr, uid, args)
            if ids == []:
                new_client_id = self.__create_partner(cr, uid, obj_res_partner, obj_profit, cli, company_id, True)
                print new_client_id
            else:
                print cli    
#        Read profit data: Proveedores
        obj_profit.execsql("""
               SELECT %s co_prov as co_cli, prov_des as cli_des, rif, direc1, ciudad, co_pais,
                      telefonos, fax, email, zip, respons 
               FROM prov where campo3 != 'ACROPOLIS' Order By cli_des"""%(top_limit)) 
        prov_profit = obj_profit.cur.fetchall()
        logger.info('module tcv_profit: import: Res partner/Proveedores...')
        prg=self.__progress_log(company_id,'Proveedores',len(prov_profit))
        for prov in prov_profit:
            prg = self.__progress_step(prg)
            rif = obj_profit.str_rif(prov['rif'])
            if rif <> '':
                args = [('vat', '=', 'VE'+rif),('company_id','=',company_id)] #query clause      
            else:
                args = [('name', '=', obj_profit.str_import(prov['cli_des'])),('company_id','=',company_id)] #query clause      
            ids = obj_res_partner.search(cr, uid, args)
            if ids == []: # No esta como cliente ahora buscar como partner
                args = [('ref', '=', obj_profit.str_import(prov['co_cli'])),('company_id','=',company_id),('supplier','=',True)] #query clause      
                ids = obj_res_partner.search(cr, uid, args)
                if ids == []: # Tampoco esta como partner, debe incluirse
                    new_prov_id = self.__create_partner(cr, uid, obj_res_partner, obj_profit, prov, company_id, False)
                else:
                    print args
                    print prov
            else: # Ya está como cliente   
                if len(ids) == 1:
                    partner = {'supplier': True} 
                    obj_res_partner.write(cr, uid, ids, partner)
                else:
                    logger.error('module tcv_profit: Import: Res partner: Multiple results in unique search: %s'%(obj_profit.str_import(prov['cli_des'])))            
        obj_profit.close()
        logger.info('module tcv_profit: import: Res partner. Done.')

    
#--------------------------------------------------------------------------------------------------Res partner title
    def __gen_res_partner_title(self, cr, uid, obj, name, domain):
        new_misc = {'name':name,
                    'shortcut':name.replace('.',''),
                    'domain':domain,
                    }
        misc_id = obj.search(cr, uid, [('name', '=',new_misc['name'])])
        return obj.create(cr, uid, new_misc) if not misc_id else misc_id


    def import_res_partner_title(self,cr,uid,ids,context=None):
        logger.info('module tcv_profit: import: Res partner title...')
        obj_res_partner_title = self.pool.get('res.partner.title')
        partner_titles = ('C.A.', 'S.R.L.','Coop.','S.A.C.A.','S.A.I.C.A.','F.U.')
        contact_titles = ('Lic.','Abg.','Dr.','Dra.','Ing.','Arq.')
        for pt in partner_titles:
            self.__gen_res_partner_title(cr, uid, obj_res_partner_title,pt,'partner')
        for ct in contact_titles:
            self.__gen_res_partner_title(cr, uid, obj_res_partner_title,ct,'contact')
        logger.info('module tcv_profit: Res partner title. Done.')


#--------------------------------------------------------------------------------------------------Stock location
    def __get_location_id(self, cr, uid, context, name, company_id, log = True):
        obj_stock_location = self.pool.get('stock.location')
        ids = obj_stock_location.search(cr, uid, [('name','=',name), ('company_id','=',company_id)]) 
        if ids:
            return ids
        else:
            #~ print 'module tcv_profit: unknow location: %s comañia: %s' % (name, company_id)
            if log:
                logger.error(u'module tcv_profit: unknow location: %s comañia: %s' % (name, company_id))
            
            
    def __generar_ubicaciones_base(self, cr, uid, context):
        # Esto es TOTALMENTE CABLEADO
        global companies
        logger.info('module tcv_profit: import: Base location...')
        OpenERPSA = 'OpenERP S.A.'
        tcv_name  = companies[0]['name']
        # Fase 1: Asignar company_id=Tecvemar a todas las locations existentes
        obj_stock_location = self.pool.get('stock.location')
        ids = obj_stock_location.search(cr, uid, [('company_id','=',None)]) 
        upd_location = {'company_id':1,}
        for id in ids:
            obj_stock_location.write(cr,uid,id,upd_location)
        #Fase 2: Retocar el nombre OpenERP s.a.
        #~ ids = obj_stock_location.search(cr, uid, [('name','ilike',OpenERPSA)]) 
        #~ upd_location = {'name':tcv_name,}
        #~ for id in ids:
            #~ obj_stock_location.write(cr,uid,id,upd_location)
        #Fase 3: Duplicar las ubicaciones en c/u de las restantes comañias
        ids = obj_stock_location.search(cr, uid, [('company_id','=',1)]) 
        for c in range(2,9):
            for id in ids:
                location = obj_stock_location.read(cr, uid, id, [], context)
                if location['location_id']:
                    parent_location_name = location['location_id'][1]
                    if parent_location_name == OpenERPSA or parent_location_name == tcv_name:
                        parent_location_name = companies[c-1]['name']
                    parent_location_id = self.__get_location_id(cr,uid,context,parent_location_name,c)[0]
                    
                else:
                    parent_location_id = 0 # sin parent location
                name = location['name']    
                if name == OpenERPSA or name == tcv_name:
                    name = companies[c-1]['name']
                new_location = {'name':name,
                                'usage':location['usage'],
                                'company_id':c,
                                'icon':location['icon'],
                                'active':location['active'],
                                'scrap_location':location['scrap_location'],
                                'chained_location_type':location['chained_location_type'],
                                'chained_auto_packing':location['chained_auto_packing'],
                                'chained_picking_type':location['chained_picking_type'],
                                'location_id':parent_location_id,
                                }
                if not self.__get_location_id(cr, uid, context, name, c, False): # no existe, crearla
                    obj_stock_location.create(cr, uid, new_location)                


    def __location_as_dict(self,company_id,name,usage,chained_auto_packing,chained_location_type,parent_id):
        #~ if not(type(parent_id) is int):
            #~ print 'Error en parent id: %s - %s'%(name,parent_id)
            #~ raise
        return {'active':True,
                'name':name,
                'usage':usage,
                'chained_auto_packing':chained_auto_packing,
                'chained_location_type':chained_location_type,
                'location_id':parent_id,
                'company_id':company_id,
                'scrap_location':False,
                }
                

    def __generar_location_dict(self, cr, uid, context, new_location, company_id):
        ids = self.__get_location_id(cr, uid, context,new_location['name'],company_id,False)
        if not ids: # no se encontró, crearla
            obj_stock_location = self.pool.get('stock.location')
            return obj_stock_location.create(cr, uid, new_location) 
        else:
            if len(ids) == 1:
                return ids[0]
            else:
                logger.error('Duplicated warehouse was found: %s, compañia: %s' % (new_location['name'], company_id))


    def __generar_location(self, cr, uid, context, name, usage, parent_id, company_id):
        new_location = self.__location_as_dict(company_id,name, usage,'manual','none',parent_id)
        return self.__generar_location_dict(cr, uid, context, new_location, company_id)


    def __estantes_burros(self,id,lon): 
        ''' Devuelve una lista tipo: 'A01','A02'..'A0n' '''
        r = []
        for s in range(0,lon+2):
            n = '%s%02d'%(id,s)
            r.append(n)
        return r

    def __generar_ubicacion_indeterminada(self, cr, uid, context):
        logger.info('module tcv_profit: import: Indeterminated location...')
        for c in range(1,9):
            parent_id = self.__get_location_id(cr, uid, context,'Stock',c)[0]
            name = 'Indeterminada'
            new_location = self.__location_as_dict(c,'Indeterminada','internal','manual','none',parent_id)
            self.__generar_location_dict(cr, uid, context, new_location, c)
            #~ name = 'Indeterminada'
            #~ if not self.__get_location_id(cr, uid, context, name, c, False):
                #~ obj_stock_location = self.pool.get('stock.location')
                #~ new_location = self.__location_as_dict(c,name,'internal','manual','none',parent_id)
                #~ obj_stock_location.create(cr, uid, new_location) 


    def __generar_galpon_laminas(self, cr, uid, context, company_id, burros):
        # generar los burros
        global companies
        parent_id = self.__get_location_id(cr, uid, context,'Stock',company_id)[0]
        l = self.__location_as_dict(company_id, 'Galpón Láminas','view','manual','none',parent_id)
        galpon_id = self.__generar_location_dict(cr, uid, context, l, company_id)
        l = self.__location_as_dict(company_id,'Burros','view','manual','none',galpon_id)
        burros_id = self.__generar_location_dict(cr, uid, context, l, company_id)     
        for burro in burros:
            logger.info('module tcv_profit: Generando burro: %s-%s'%(burro[0],companies[company_id-1]['name']))
            for j in range(1,burro[1]+1):
                b = '%s%02d'%(burro[0],j)
                burro_id = self.__generar_location(cr, uid, context, b,'view',burros_id, company_id)
                for e in self.__estantes_burros(b,burro[2]):
                    estante_id = self.__generar_location(cr, uid, context, e,'internal',burro_id, company_id)


    #~ def __generar_galpon_laminas(self, cr, uid, context, company_id,letras,ult_burro):
        #~ # generar los burros
        #~ parent_id = self.__get_location_id(cr, uid, context,'Stock',company_id)[0]
        #~ l = self.__location_as_dict(company_id, 'Galpón Láminas','view','manual','none',parent_id)
        #~ galpon_id = self.__generar_location_dict(cr, uid, context, l, company_id)
        #~ l = self.__location_as_dict(company_id,'Burros','view','manual','none',galpon_id)
        #~ burros_id = self.__generar_location_dict(cr, uid, context, l, company_id)     
        #~ for i in range(ord(letras[0]),ord(letras[1])+1):
            #~ for j in range(1,ult_burro+1):
                #~ b = '%s%02d'%(chr(i),j)
                #~ burro_id = self.__generar_location(cr, uid, context, b,'view',burros_id, company_id)
                #~ for e in self.__estantes_burros(b,17):
                    #~ estante_id = self.__generar_location(cr, uid, context, e,'internal',burro_id, company_id)


    def import_stock_location(self, cr, uid, ids, context):
        logger.info('module tcv_profit: import: Stock location...')
        
        # TODO Faltan las columnas de todos ------------- !!!!!!!!!!!!!!
        
        self.__generar_ubicaciones_base(cr, uid, context)
        self.__generar_ubicacion_indeterminada(cr, uid, context)
        #~ self.__generar_galpon_laminas(cr, uid, context, 1,('A','G'),9) #Burros de tecvemar
        burros = (('A',9,17),('B',9,17),('C',9,17),('D',9,17),('E',9,17),('F',9,17),('G',9,17))
        self.__generar_galpon_laminas(cr, uid, context, 1, burros) #Burros de tecvemar
        burros = (('A',2,17),('B',2,17),('C',3,17),('D',2,17))
        self.__generar_galpon_laminas(cr, uid, context, 2, burros) #Burros de barcelona
        burros = (('A',3,17),('B',3,17),('C',3,17))
        self.__generar_galpon_laminas(cr, uid, context, 3, burros) #Burros de Guayana
        burros = (('A',5,17),('B',4,17),('C',4,17))
        self.__generar_galpon_laminas(cr, uid, context, 4, burros) #Burros de Monagas
        # TODO falta Valencia
        burros = (('A',9,17),('B',8,17),('C',8,17))
        self.__generar_galpon_laminas(cr, uid, context, 6, burros) #Burros de Maracay
        burros = (('A',6,17),('B',3,17),('C',1,17))
        self.__generar_galpon_laminas(cr, uid, context, 7, burros) #Burros de Barquisimeto
        burros = (('A',5,17),('B',4,17))
        self.__generar_galpon_laminas(cr, uid, context, 8, burros) #Burros de Falcón
        logger.info('module tcv_profit: Stock location. Done.')
        

    def __gen_new_account(self,cr,uid,company_id,parent_id,partner,type,user_type,obj_account_account,obj_account_account_type):
        #~ obj_account_account = self.pool.get('account.account')
        #~ obj_account_account_type = self.pool.get('account.account.type')
        base_code = obj_account_account.read(cr,uid,parent_id,['code'])['code']
        code = '%s%00005d'%(base_code,partner['id']+100)
        user_type_id = obj_account_account_type.search(cr,uid,[('code','=',user_type)])[0]
        new_account = {'name':partner['name'],
                       'code':code,
                       'parent_id':parent_id,
                       'company_id':company_id,
                       'type':type,
                       'user_type':user_type_id,
                       }
        return new_account
        
        
    def __gen_res_partner_account(self,cr,uid,condition,company_id,parent_id,partner,type,user_type,partner_prop,obj_account_account,obj_res_partner,obj_account_account_type):    
        if condition:  
            #~ obj_account_account = self.pool.get('account.account')
            #~ obj_res_partner = self.pool.get('res.partner')
            new_account = self.__gen_new_account(cr,uid,company_id,parent_id,partner,type,user_type,obj_account_account,obj_account_account_type)
            id = obj_account_account.search(cr,uid,[('code','=',new_account['code']),('company_id','=',company_id)])
            if not id:
                account_id = obj_account_account.create(cr,uid,new_account)
                upd_partner = {partner_prop:account_id}
                obj_res_partner.write(cr,uid,partner['id'],upd_partner)
    
    
    def create_res_partner_accounts(self,cr,uid,ids,context):
        logger.info('module tcv_profit: Create partner accounts...')
        company_id = self.read(cr, uid, ids, [],context=context)[0]['company_id']
        obj_res_partner = self.pool.get('res.partner')
        obj_account_account = self.pool.get('account.account')
        obj_account_account_type = self.pool.get('account.account.type')
        x = 3550
        y = 50
        ids = obj_res_partner.search(cr,uid,[('id','>',x+8),('id','<',x+y+8),('company_id','=',company_id)])  # 
        prg=self.__progress_log(company_id,'Partner accounts',len(ids))
        for id in ids:
            prg = self.__progress_step(prg)
            # leer de uno en uno
            partner = obj_res_partner.read(cr,uid,id,['id','ref','name','customer','supplier','country_id'])
            #Crear la CxC
            cxc = '11320'
            parent_id = obj_account_account.search(cr,uid,[('code','=',cxc),('company_id','=',company_id)])[0]
            self.__gen_res_partner_account(cr,uid,partner['customer'],company_id,parent_id,partner,
                                           'receivable','receivable','property_account_receivable',
                                           obj_account_account,obj_res_partner,obj_account_account_type)
            #Crear la CxC
            cxp = '21201'                              
            parent_id = obj_account_account.search(cr,uid,[('code','=',cxp),('company_id','=',company_id)])[0]
            self.__gen_res_partner_account(cr,uid,partner['supplier'],company_id,parent_id,partner,
                                           'payable','payable','property_account_payable',
                                           obj_account_account,obj_res_partner,obj_account_account_type)
               
        logger.info('module tcv_profit: Create partner accounts. Done.')


#--------------------------------------------------------------------------------------------------import_button_click
    def import_button_click(self,cr,uid,ids,context=None):
        global country_id_vzla
        origen = self.read(cr, uid, ids, [],context=context)[0]['import_model']
        country_id_vzla = self.__get_country_id(cr,uid,'VE')
        
        if origen == 'res_company':
            self.import_res_company(cr,uid,ids,context)
        elif origen == 'account_payment_term':
            self.import_account_payment_term(cr,uid,ids,context)
        elif origen == 'account_journal':
            self.import_account_journal(cr,uid,ids,context)
        elif origen == 'product_category':
            self.import_product_category(cr,uid,ids,context)
        elif origen == 'stock_inventory':
            self.import_stock_inventory(cr,uid,ids,context)
        elif origen == 'res_partner':
            self.import_res_partner(cr,uid,ids,context)
        elif origen == 'res_partner_title':
            self.import_res_partner_title(cr,uid,ids,context)
        elif origen == 'stock_location':
            self.import_stock_location(cr,uid,ids,context)    
            
        elif origen == 'res_partner_accounts':
            self.create_res_partner_accounts(cr,uid,ids,context)        
        #DONE añadir mensaje de finalización   
        obj_model = self.pool.get('ir.model.data')
        model_data_ids = obj_model.search(cr,uid,[('model','=','ir.ui.view'),('name','=','view_message_form')])
        resourse_id = obj_model.read(cr,uid,model_data_ids,fields=['res_id'])[0]['res_id']
        end_msg = {'type': 'ir.actions.act_window',
                   'res_model':'message.end',
                   'view_type':'form',
                   'view_mode':'form',
                   'views':[(resourse_id,'form')],
                   'target':'new', 
                   'context':context,}
        return end_msg
        
tcv_profit()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
